# Network Hardware

## Hosts
Hosts are the actual clients/devices on a network. 
Examples: Computers, printers, servers, etc....

## Hubs / Repeaters
Hubs connect hosts in [[Network Types#Broadcast network]] networks, they forward all messages in all possible directions. This means that hubs are non-intelligent.
![[hubs.png]]

## Switches
Switches like hubs also connect hosts in broadcast networks. Switches however forward messages in the direction of their intended receivers. This makes the switches intelligent.

This property of a switch is called filtering.

Switches contain a table that stores all [[MAC-Address]] of connected devices (of each port) in a table.

They read the frame of a incoming message, extract the destination MAC Address and forward it to the corresponding port on the switch.

## Bridges


## Routers
Router is a member of multiple networks.

![[routers-example.png]]

For each connection to a network a routers uses a network interface card (NIC) and a IP address.

This way a router can have multiple IP addresses.

Each connection is identified by a interface, label or an address.

Example of a routing table:
![[routing-table.png]]

### Updating router tables
Routers are responsible for updating routing tables themselves.

When a router detects a change in connections, it immediately informs other routers about it.

Routers use optimum route finding algorithms to update their tables.

Exchanging routing information between routers is done periodically even when there is no change in the network.

The most commonly used routing algorithms are:
- Distance vector routing (RIP)
- Link-state Routing (OSPF, IS-IS)






